#pragma once
 
#include "tchar.h"
#include "windows.h"

class CProcess
{
public:
	// ܵ
	enum PipeType { pIn, pOut, pErr };
	// дʽ
	enum Direction { Read, Write };
	// ִеķʽ
	enum ExecType { ASYNC, SYNC };

	CProcess();
	CProcess(ExecType execType);
	~CProcess();
	// һִָзʽĽ
	BOOL Create(ExecType execType);
	// ִнű
	BOOL Execute(LPCTSTR Command);
	// Ƿ
	BOOL IsOk() { return m_hPipes[pIn][Write] != INVALID_HANDLE_VALUE; }
	// ȡid
	DWORD GetPid() { return m_dwProcessId; }
	// ӹܵȡһ
	size_t ReadLine(LPVOID lpBuffer, size_t len, char seq = '\n');
	// ܵд
	size_t WriteSome(LPVOID lpBuffer, size_t len);
	// رչܵ
	void ClosePipes();
protected:
	BOOL CreatePipes();
	
private:
	DWORD m_dwProcessId;
	HANDLE m_hPipes[3][2];
	ExecType m_execType;
};

