#pragma once
# ifndef LOG_SYS_H
# define LOG_SYS_H

# include <iostream>
# include <fstream>
# include <string>
# include <time.h>
# include <stdio.h>
# include <stdlib.h>
#include <windows.h>

using std::cout;
using std::string;
using std::endl;
using std::to_string;
using std::ios;


class Logger : public SSingleton<Logger> {
public:
	enum log_level { debug, info, warning, error };// ־ȼ
	enum log_target { file, terminal, file_and_terminal };// ־Ŀ
private:

	string currTime() {
		// ȡǰʱ䣬淶ʾ
		char tmp[64];
		time_t ptime;
		time(&ptime);  // time_t time (time_t* timer);
		strftime(tmp, sizeof(tmp), "%Y-%m-%d %H:%M:%S", localtime(&ptime));
		return tmp;
	}



	std::ofstream outfile;    // ־ļ
	log_target target;        // ־Ŀ
	string path;              // ־ļ·
	log_level level;          // ־ȼ
	void output(string text, log_level act_level);            // Ϊ
public:
	Logger();  // ĬϹ캯
	void Init(log_target target, log_level level, string path = "");
	void DEBUG(string text);
	void INFO(string text);
	void WARNING(string text);
	void LERROR(string text);
};

# endif
