#pragma once
// Զ¼Ϣ


#define EVT_LOGIN (SOUI::EVT_EXTERNAL_BEGIN + 1000)

class EventLogin : public TplEventArgs<EventLogin>
{
	SOUI_CLASS_NAME(EventLogin, L"on_event_login")
public:
	EventLogin(SOUI::SWindow* pSender) : TplEventArgs<EventLogin>(pSender)
	{

	}
	enum {
		EventID = EVT_LOGIN
	};

	int		 status;
	SStringW msg;
};



#define EVT_DOWNLOAD (SOUI::EVT_EXTERNAL_BEGIN + 1001)

class EventDoWNload : public TplEventArgs<EventDoWNload>
{
	SOUI_CLASS_NAME(EventDoWNload, L"on_event_download")
public:
	EventDoWNload(SOUI::SWindow* pSender) : TplEventArgs<EventDoWNload>(pSender)
	{

	}
	enum {
		EventID = EVT_DOWNLOAD
	};

	int		 status;
	SStringW msg;
};


#define EVT_NODELIST (SOUI::EVT_EXTERNAL_BEGIN + 1002)

class EventNodeList : public TplEventArgs<EventNodeList>
{
	SOUI_CLASS_NAME(EventNodeList, L"on_event_nodelist")
public:
	EventNodeList(SOUI::SWindow* pSender) : TplEventArgs<EventNodeList>(pSender)
	{

	}
	enum {
		EventID = EVT_NODELIST
	};

	int		 status;
	SStringW msg;
};


#define EVT_CLASH_PREOCEE_QUT (SOUI::EVT_EXTERNAL_BEGIN + 1003)

class EventClashPreOceeQut : public TplEventArgs<EventClashPreOceeQut>
{
	SOUI_CLASS_NAME(EventClashPreOceeQut, L"on_event_clash_qut")
public:
	EventClashPreOceeQut(SOUI::SWindow* pSender) : TplEventArgs<EventClashPreOceeQut>(pSender)
	{

	}
	enum {
		EventID = EVT_CLASH_PREOCEE_QUT
	};

	int		 status;
	SStringW msg;
};


#define EVT_VERIONS (SOUI::EVT_EXTERNAL_BEGIN + 1004)

class EventVerions : public TplEventArgs<EventVerions>
{
	SOUI_CLASS_NAME(EventVerions, L"on_event_version")
public:
	EventVerions(SOUI::SWindow* pSender) : TplEventArgs<EventVerions>(pSender)
	{

	}
	enum {
		EventID = EVT_VERIONS
	};

	int		 status;
	SStringW msg;
	int		 versionupdate;
};


#define EVT_SYSCONFIG (SOUI::EVT_EXTERNAL_BEGIN + 1005)

class EventSysconfig : public TplEventArgs<EventSysconfig>
{
	SOUI_CLASS_NAME(EventSysconfig, L"on_event_sysconfig")
public:
	EventSysconfig(SOUI::SWindow* pSender) : TplEventArgs<EventSysconfig>(pSender)
	{

	}
	enum {
		EventID = EVT_SYSCONFIG
	};

	int		 status;
	SStringW msg;
};


enum struct ConnectState
{
	Stop,
	SwitchConfigSuccEss,
	SwitchNodeSuccEss,
};

#define EVT_CONNECT (SOUI::EVT_EXTERNAL_BEGIN + 1005)

class EventConnect : public TplEventArgs<EventConnect>
{
	SOUI_CLASS_NAME(EventConnect, L"on_event_connect")
public:
	EventConnect(SOUI::SWindow* pSender) : TplEventArgs<EventConnect>(pSender)
	{

	}
	enum {
		EventID = EVT_CONNECT
	};

	ConnectState status;
	SStringW	 msg;
};


#define EVT_AUTH (SOUI::EVT_EXTERNAL_BEGIN + 1008)

class EventAUTH : public TplEventArgs<EventAUTH>
{
	SOUI_CLASS_NAME(EventAUTH, L"on_event_auth")
public:
	EventAUTH(SOUI::SWindow* pSender) : TplEventArgs<EventAUTH>(pSender)
	{

	}
	enum {
		EventID = EVT_AUTH
	};

	int		 status;
	SStringW msg;
};